<?php
/**
* @version      2.2.2 29.08.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerCategories extends JController{
    
    function __construct( $config = array() ){
        parent::__construct( $config );

        $this->registerTask( 'add',   'edit' );
        $this->registerTask( 'apply', 'save' );
        $_SERVER['QUERY_STRING'] = "index.php?option=com_jshopping&controller=categories&catid=0";//submenu active
    }
    
    function display() {
    global $mainframe;
        $jshopConfig = &JSFactory::getConfig();
        $_categories = &$this->getModel("categories");
        
        $context = "jshopping.list.admin.category";
        $catid = $mainframe->getUserStateFromRequest( $context.'catid', 'catid', 0, 'int');
        
        $categories = $_categories->getSubCategories($catid, 'ordering');
        $parentTop->category_id = 0;
        $parentTop->name = _JSHOP_TOP_LEVEL;
        $categories_select = buildTreeCategory(0);
        array_unshift($categories_select, $parentTop);    
        $lists['treecategories'] = JHTML::_('select.genericlist', $categories_select,'catid','class="inputbox" id = "category_ordering" size="1" onchange = "document.adminForm.submit();"','category_id','name', $catid );
        
        $view=&$this->getView("category_list", 'html');
        $view->assign('categories', $categories);
        $view->assign('lists', $lists);
        $view->display();        
    }
    
    function edit() {
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();        
        $cid = JRequest::getInt("category_id");        
        
        $category = &JTable::getInstance("category","jshop");
        $category->load($cid);
        
        $_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        $multilang = count($languages)>1;
        
        $nofilter = array();
        foreach($languages as $lang){
            $nofilter[] = "description_".$lang->language;
        }
        JFilterOutput::objectHTMLSafe( $category, ENT_QUOTES, $nofilter);
        
        if(!$cid) {
            $category->products_sorting = 1;
            $category->products_sorting2 = 1;
            $category->category_publish = 1;
        }

        if ($cid) {
            $parentid = $category->category_parent_id;
            $rows = $this->_getAllCategoriesLevel($category->category_parent_id, $category->category_ordering);            
        } else {
            $parentid = JRequest::getInt("catid");
            $rows = $this->_getAllCategoriesLevel($parentid);
        }

        $lists['writeable'] = (is_writable($jshopConfig->image_category_path))?($jshopConfig->image_category_path . '::' . messageOutput(_JSHOP_WRITEABLE,'jshop_green')):($jshopConfig->image_category_path . '::' . messageOutput(_JSHOP_NON_WRITEABLE));
        $lists['templates'] = getTemplates('category', $category->category_template);
        $lists['onelevel'] = $rows;    
        
        $parentTop->category_id = 0;
        $parentTop->name = _JSHOP_TOP_LEVEL;
        $categories = buildTreeCategory(0);
        array_unshift($categories, $parentTop);

        $orderingtype[] = JHTML::_('select.option', 1,_JSHOP_MANUAL,'ordering_type_id','ordering_type_value');
        $orderingtype[] = JHTML::_('select.option', 2,_JSHOP_ALPH,'ordering_type_id','ordering_type_value');

        $lists['orderingtype'] = JHTML::_('select.genericlist', $orderingtype,'category_ordertype','class = "inputbox" size = "1"','ordering_type_id','ordering_type_value',$category->category_ordertype);
        $lists['treecategories'] = JHTML::_('select.genericlist', $categories,'category_parent_id','class="inputbox" id = "category_ordering" size="1" onchange = "changeCategory()"','category_id','name', $parentid);
        $lists['parentid'] = $parentid;
        $lists['product_sorting'] = $this->_generateSelectSorting($category->products_sorting,'products_sorting');
        $lists['product_sorting2'] = $this->_generateSelectSorting($category->products_sorting2,'products_sorting2');
        
        $view=&$this->getView("category_edit", 'html');
        $view->assign('category', $category);
        $view->assign('lists', $lists);
        $view->assign('languages', $languages);
        $view->assign('multilang', $multilang);
        $view->display();
    }
    
    function save() {        
        global $mainframe;
        $jshopConfig = &JSFactory::getConfig();        
        
        require_once ($jshopConfig->path.'lib/thumbnail_images.class.php');
        require_once ($jshopConfig->path.'lib/uploadfile.class.php');
        
        $db = &JFactory::getDBO();
        
        $category = &JTable::getInstance("category","jshop");
        if(!$_POST["category_id"]){
            $_POST['category_add_date'] = date("Y-m-d H:i:s");
        }
        if(!isset($_POST['category_publish'])){
            $_POST['category_publish'] = 0;
        }
        
        $post = JRequest::get('post');
        $_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        
        foreach($languages as $lang){            
            $post['description_'.$lang->language] = JRequest::getVar('description'.$lang->id,'','post',"string", 2);
        }

        if(!$category->bind($post)) {
            JError::raiseWarning("",_JSHOP_ERROR_BIND);
            $this->setRedirect("index.php?option=com_jshopping&controller=categories");
            return 0;
        }
        $edit = $category->category_id;
       
        $upload = new UploadFile($_FILES['category_image']);
        $upload->setAllowFile(array('jpeg','jpg','gif','png'));
        $upload->setDir($jshopConfig->image_category_path);
        if ($upload->upload()){            
            if($category->category_image) {
                @unlink($jshopConfig->image_category_path . "/" . $category->category_image);
            }
            $name = $upload->getName();
            
            if($post['size_im_category'] < 3){
                if($post['size_im_category'] == 1){
                    $category_width_image = $jshopConfig->image_category_width; 
                    $category_height_image = $jshopConfig->image_category_height;
                }else{
                    $category_width_image = JRequest::getInt('category_width_image'); 
                    $category_height_image = JRequest::getInt('category_height_image');
                }
                
                $img = new thumbnail_images();
                $img->PathImgOld = $jshopConfig->image_category_path."/".$name;
                $img->PathImgNew =  $jshopConfig->image_category_path."/".$name;
                $img->NewWidth = $category_width_image;
                $img->NewHeight = $category_height_image;

                if(!$img->create_thumbnail_images()){
                    JError::raiseWarning("",_JSHOP_ERROR_CREATE_THUMBAIL);
                }    
                unset($img);
            }
            
            $category->category_image = $name;
            
        }else{
            if ($upload->getError() != 4){
                JError::raiseWarning("", _JSHOP_ERROR_UPLOADING_IMAGE);
            }
        }

        $this->_reorderCategory($category);
         
        if(!$category->store()) {
            JError::raiseWarning("",_JSHOP_ERROR_SAVE_DATABASE);
            $this->setRedirect("index.php?option=com_jshopping&controller=categories");
            return 0;
        }
        
        $success = ($edit)?(_JSHOP_CATEGORY_SUCC_UPDATE):(_JSHOP_CATEGORY_SUCC_ADDED);
        
        if ($this->getTask()=='apply'){
            $this->setRedirect('index.php?option=com_jshopping&controller=categories&task=edit&category_id='.$category->category_id, $success);
        }else{
            $this->setRedirect('index.php?option=com_jshopping&controller=categories', $success);
        }        
    }

    function order(){
        $db = &JFactory::getDBO();
        $order = JRequest::getVar("order");
        $cid = JRequest::getInt("id");
        $number = JRequest::getInt("number");
        $category = &JTable::getInstance("category","jshop");
        $category->load($cid);

        switch ($order) {
            case 'up':
                $query = "SELECT a.category_id, a.category_ordering
                       FROM `#__jshopping_categories` AS a
                       WHERE a.category_ordering < '" . $number . "' AND a.category_parent_id = '" . $category->category_parent_id . "'
                       ORDER BY a.category_ordering DESC
                       LIMIT 1";
                break;
            case 'down':
                $query = "SELECT a.category_id, a.category_ordering
                       FROM `#__jshopping_categories` AS a
                       WHERE a.category_ordering > '" . $number . "' AND a.category_parent_id = '" . $category->category_parent_id . "'
                       ORDER BY a.category_ordering ASC
                       LIMIT 1";
        }

        $db->setQuery($query);
        $row = $db->loadObject();

        $query1 = "UPDATE `#__jshopping_categories` AS a
                     SET a.category_ordering = '" . $row->category_ordering . "'
                     WHERE a.category_id = '" . $cid . "'";
        $query2 = "UPDATE `#__jshopping_categories` AS a
                     SET a.category_ordering = '" . $number . "'
                     WHERE a.category_id = '" . $row->category_id . "'";
        $db->setQuery($query1);
        $db->query();

        $db->setQuery($query2);
        $db->query();

        $this->setRedirect('index.php?option=com_jshopping&controller=categories');
    }
    
    function _getAllCategoriesLevel($parentId, $currentOrdering = 0) {
        $jshopConfig = &JSFactory::getConfig();
        $_categories = &$this->getModel("categories");
        $rows = $_categories->getSubCategories($parentId, "ordering");
        $first[] = JHTML::_('select.option', '0',_JSHOP_ORDERING_FIRST,'category_ordering','name');
        $rows = array_merge($first,$rows);
        $currentOrdering = (!$currentOrdering) ? ($rows[count($rows) - 1]->category_ordering) : ($currentOrdering);
        return (JHTML::_('select.genericlist', $rows,'category_ordering','class="inputbox" size="1"','category_ordering','name',$currentOrdering));
    }
    
    function _generateSelectSorting($field_id, $name_select) {
        $ordering_category = array(1 => _JSHOP_ALPH, _JSHOP_PRICE, _JSHOP_DATA, _JSHOP_MANUAL);
        foreach ($ordering_category as $key => $value) {
            $field->id = $key;
            $field->name = $value;
            $select[] = $field;
            $field = null;
        }
        return JHTML::_('select.genericlist', $select,$name_select,'','id','name',$field_id);
    }
    
    
    function _reorderCategory(&$category) {
        $db = &JFactory::getDBO();
        $query = "UPDATE `#__jshopping_categories` SET `category_ordering` = category_ordering + 1
                    WHERE `category_parent_id` = '" . $category->category_parent_id . "' AND `category_ordering` > '" . $category->category_ordering . "'";
        $db->setQuery($query);
        $db->query();
        $category->category_ordering++;
    }
    
    function publish(){
        $this->publishCategory(1);
        $this->setRedirect('index.php?option=com_jshopping&controller=categories');
    }
    
    function unpublish(){
        $this->publishCategory(0);
        $this->setRedirect('index.php?option=com_jshopping&controller=categories');
    }
    
    function publishCategory($flag) {
        $db = &JFactory::getDBO();
        $cid = JRequest::getVar("cid");
        foreach ($cid as $key => $value) {
            $query = "UPDATE `#__jshopping_categories` SET `category_publish` = '" . $db->getEscaped($flag) . "'
                      WHERE `category_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();
        }                
    }
    
    function remove() {
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        $text = array();
        $cid = JRequest::getVar("cid");
        $_categories = &$this->getModel("categories");
        foreach ($cid as $key => $value) {
            $category = &JTable::getInstance("category", "jshop");
            $category->load($value);
            $name_category = $category->getName();
            if($category->getCountProducts(0)){
                $text[]= sprintf(_JSHOP_CATEGORY_NO_DELETED, $name_category);
                continue;
            }
            $_categories->deleteCategory($value);
            @unlink($jshopConfig->image_category_path.'/'.$category->category_image);
            $text[]= sprintf(_JSHOP_CATEGORY_DELETED, $name_category);
        }
        
        $this->setRedirect('index.php?option=com_jshopping&controller=categories', implode('</li><li>',$text));
    }
    
    function sorting_cats_html(){
        $catid = JRequest::getVar('catid');
        print $this->_getAllCategoriesLevel($catid);
    die();    
    }
    
    function delete_foto(){
        $catid = JRequest::getInt("catid");
        $jshopConfig = &JSFactory::getConfig();
        $category = &JTable::getInstance("category", "jshop");
        $category->load($catid);
        @unlink($jshopConfig->image_category_path.'/'.$category->category_image);
        $category->category_image = "";
        $category->store();
        die();
    }
    
    
}
?>